# Flask-Bootstrap-Demo
This is a simple web app demo using Flask, Flask-login, Flask-SQLAlchemy, and a SQLite3 database. 

### Technology

Flask-Bootstrap-Demo uses a multiple python libraries:
* [Python 2.7](https://www.python.org/) - Python is a programming language that lets you work quickly and integrate systems more effectively.
* [Flask](http://flask.pocoo.org/) - Flask is a microframework for Python based on Werkzeug, Jinja 2 and good intentions.
* [Flask-Login](https://flask-login.readthedocs.io/en/latest/) - Flask-Login provides user session management for Flask.
* [Flask-Bcrypt](https://flask-bcrypt.readthedocs.io/en/latest/) - Flask-Bcrypt is a Flask extension that provides bcrypt hashing utilities for your application.
* [Bootstrap](http://getbootstrap.com/) - Bootstrap is the most popular HTML, CSS, and JS framework for developing responsive, mobile first projects on the web.
* [SQLite3](https://docs.python.org/2/library/sqlite3.html) - SQLite is a C library that provides a lightweight disk-based database

### Installation
Install the dependencies.
```sh
$ python -m pip install -r requirements.txt
```

### Run
```
python app.py
```